質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

88.92%

Python 組み込み例外 ドキュメントについて

解決済

回答 1

投稿

  • 評価
  • クリップ 2
  • VIEW 152

nouken

score 349

https://docs.python.org/ja/3/library/exceptions.html#KeyboardInterrupt

Python において、すべての例外は BaseException から派生したクラスのインスタンスでなければなりません。特定のクラスを言及する except 節を伴う try 文において、その節はそのクラスから派生した例外クラスも処理しますが、そのクラスの派生 元 の例外クラスは処理しません。サブクラス化の関係にない 2 つの例外クラスは、それらが同じ名前だった場合でも等しくなりえません。

上のリンクの以上のような記載があるのですが、最後の一文がいまいち理解できません。

サブクラス化しようがしまいが、二つ同じ名前の例外が同時に存在する状況が考えられないのですが、「等しくなりえません」とあるのはそれらが比較可能(つまり同時に存在する?)ことを意味しているのでしょうか。。。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+2

たとえば、次のようなコードを実行します:

project
+---packagea
|   +---__init__.py
+---packageb
|   +---__init__.py
+---test.py

packagea/init.py:

class SomeException(Exception):
    pass

packageb/init.py:

class SomeException(Exception):
    pass

def test():
    raise SomeException()

test.py:

from packagea import SomeException
from packageb import test

try:
    test()
except SomeException as error:
    print("Caught!")

実行結果:

$ python test.py
Traceback (most recent call last):
  File "test.py", line 5, in <module>
    test()
  File "C:\Users\Public\workspace\test-python\packageb\__init__.py", line 5, in test
    raise SomeException()
packageb.SomeException

上記のように、パッケージを分けるなどすれば、
二つ同じ名前の例外が同時に存在することはあり得ます
パッケージは無数に存在するので、このようなことは珍しいことでもありません

そして、上記の実行結果のように、
たとえば、同じ名前の例外でも異なるパッケージであれば
その例外は except ブロックでキャッチされることはありません

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 88.92%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る